


###############################################
#BREAST CANCER MORTALITY. Greenland data#######
###############################################


datos<-rbind(cbind(rep(1,12),rep(1,12),c(rep(1,2),rep(0,10))),
cbind(rep(1,55),rep(2,55),c(rep(1,5),rep(0,50))),
cbind(rep(2,22),rep(1,22),c(rep(1,9),rep(0,13))),
cbind(rep(2,74),rep(2,74),c(rep(1,17),rep(0,57))),
cbind(rep(3,14),rep(1,14),c(rep(1,12),rep(0,2))),
cbind(rep(3,15),rep(2,15),c(rep(1,9),rep(0,6))))

datos<-data.frame(datos)

names(datos)<-c("Stage","Receptor_Level","Dead");
var=datos$Receptor_Level;

for(i in 1:nrow(datos)){
if((datos$Receptor_Level)[i]==2){var[i]=0;}
}

datos<-data.frame(cbind(datos$Stage,var,datos$Dead));
names(datos)<-c("Stage","Receptor_Level","Dead");

names(datos)<-c("x1","x2","y")

###################################


library(np)
library(mvtnorm)
library(MASS)


long.cadena<-50000



#Modelo 2#

res<-glm(y~factor(x2)+factor(x1),family=binomial(logit),data=datos,x=T);
summary(res);
beta=data.frame(res$coef);
beta=beta[1:nrow(beta),];
X=res$x;
X=X[1:nrow(X),1:ncol(X)];
res2<-res;



#Desde hasta segn el orden en summary(res)#

desde<-2;
hasta<-2;
lugar<-1:ncol(res$x);
lugar<-c(desde:hasta,lugar[-(desde:hasta)]);



#Modelo 1#

res1<-glm(y~factor(x1),family=binomial(logit),data=datos,x=T)




y.sample<-datos$y

X<-X[,lugar];
k0<-hasta-desde+1;

veces1<-repfA(X[,(k0+1):ncol(X)]);
veces2<-repfA(X);

theta2<-matrix(beta,nrow=ncol(X))

system.time({
tabla1<-{};
tabla2<-{};
for(nsim in 1:long.cadena){
punto<-transition(theta2,X,k0,veces1,veces2);
theta1<-punto[,1];
theta2<-punto[,2];
tabla1<-cbind(tabla1,theta1);
tabla2<-cbind(tabla2,theta2);}
})





#FIGURE 1#

op <- par(mfrow = c(2, 2))
for(i in 1:4){
plot(density(tabla2[i,]),xlim=c(-20,20),ylim=c(0,.25),ylab="",xlab="",main="",las=1);}




#################################################
#THE FOLLOWING SENTENCE COMPUTES THE POSTERIOR PROBABILITY 
#OF THE MODEL M2 BASED ON THE ABOVE MARKOV CHAINS AND
#USING IMPORTANCE SAMPLING WITH 10000 SIMULATION
#################################################


postProbM2(res1,res2,tabla1,tabla2,desde,hasta,y.sample,10000)














