
library(foreign)
datos<-data.frame(read.spss("peso_nacimiento.sav"))
names(datos)


x<-rep(0,nrow(datos));
for(i in 1:nrow(datos)){
if(datos$AGE[i]>18 & datos$AGE[i]<=20){x[i]=1;}
if(datos$AGE[i]>20 & datos$AGE[i]<=25){x[i]=2;}
if(datos$AGE[i]>25 & datos$AGE[i]<=30){x[i]=3;}
if(datos$AGE[i]>30 & datos$AGE[i]<=35){x[i]=4;}
if(datos$AGE[i]>35 & datos$AGE[i]<=40){x[i]=4;}
if(datos$AGE[i]>40){x[i]=4;}
;}
edad5c<-x
rm(x)
datos<-cbind(datos,edad5c)


###################################################


library(np)
library(mvtnorm)
library(MASS)


long.cadena<-30000
simul<-10000



#SMOKE#

#Modelo 2#

res<-glm(LOW~factor(SMOKE)+factor(RACE)+factor(edad5c)+factor(PTL>0),family=binomial(logit),data=datos,x=T);
summary(res);
beta=data.frame(res$coef);
beta=beta[1:nrow(beta),];
X=res$x;
X=X[1:nrow(X),1:ncol(X)];
res2<-res;


#Desde hasta segn el orden en summary(res)#

desde<-2;
hasta<-2;

lugar<-1:ncol(res$x);
lugar<-c(desde:hasta,lugar[-(desde:hasta)]);



#Modelo 1#

res1<-glm(LOW~factor(RACE)+factor(edad5c)+factor(PTL>0),family=binomial(logit),data=datos,x=T);



y.sample<-datos$LOW;


X<-X[,lugar];
k0<-hasta-desde+1;
veces1<-repfA(X[,(k0+1):ncol(X)]);
veces2<-repfA(X);


theta2<-matrix(beta,nrow=ncol(X));

system.time({
tabla1<-{};
tabla2<-{};
for(nsim in 1:long.cadena){
punto<-transition(theta2,X,k0,veces1,veces2);
theta1<-punto[,1];
theta2<-punto[,2];
tabla1<-cbind(tabla1,theta1);
tabla2<-cbind(tabla2,theta2);}
})


#FIGURE 2#

plot(density(tabla2[1,]),xlim=c(-20,20),ylim=c(0,.15),ylab="",xlab="",main="",las=1)
for(i in 2:9){
par(new=T);
plot(density(tabla2[i,]),lty=2,xlim=c(-20,20),ylim=c(0,.15),ylab="",xlab="",main="",las=1,axes=FALSE);
}


#################################################
#THE FOLLOWING SENTENCE COMPUTES THE POSTERIOR PROBABILITY 
#OF THE MODEL M2 BASED ON THE ABOVE MARKOV CHAINS AND
#USING IMPORTANCE SAMPLING WITH 10000 SIMULATION
#################################################

postProbM2(res1,res2,tabla1,tabla2,desde,hasta,y.sample,simul=30000)

